diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index f3e27b964..8c44b4b62 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -126,7 +126,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
             getModel("main").translateToBone("mouthItem");
             GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
             GLRenderer.enableState(State.BLEND);
-            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getLightmap(partialTick), partialTick, true);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, GameSettings.ITEMS_3D.value, 1, entity.getLightmap(partialTick), partialTick, true);
             GLRenderer.disableState(State.BLEND);
             GLRenderer.popFrame();
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 6e0d8f18e..52e2f3e1c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -717,7 +717,7 @@ public class FontRendererDefault extends FontRenderer {
     }
 
     public @NotNull Font getFont() {
-        return this.font == null ? Minecraft.getMinecraft().gameSettings.font.value : this.font;
+        return this.font == null ? GameSettings.FONT.value : this.font;
     }
 
     public static int decodeHexToInt(final @NotNull CharSequence hexSequence) throws NumberFormatException {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index 9a03a9a07..9aa8f30be 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -150,7 +150,7 @@ public class Particle {
             switch (hitTile.side) {
                 case EAST:
                 case WEST: {
-                    this.x = hitTile.location.x() + hitTile.side.getOffsetX() * 0.01d * this.size;
+                    this.x = hitTile.location.x() + hitTile.side.getOffsetX() * 0.1d * this.size;
                     this.y += yd;
                     this.z += zd;
                     this.xd = 0;
@@ -160,7 +160,7 @@ public class Particle {
                     this.onGround = true;
                 case BOTTOM: {
                     this.x += xd;
-                    this.y = hitTile.location.y() + hitTile.side.getOffsetY() * 0.01d * this.size;
+                    this.y = hitTile.location.y() + hitTile.side.getOffsetY() * 0.1d * this.size;
                     this.z += zd;
                     this.yd = 0;
                     break;
@@ -169,7 +169,7 @@ public class Particle {
                 case NORTH: {
                     this.x += xd;
                     this.y += yd;
-                    this.z = hitTile.location.z() + hitTile.side.getOffsetZ() * 0.01d * this.size;
+                    this.z = hitTile.location.z() + hitTile.side.getOffsetZ() * 0.1d * this.size;
                     this.zd = 0;
                     break;
                 }
@@ -206,6 +206,7 @@ public class Particle {
         final int signY = (int) org.joml.Math.signum(ray.dY);
         final int signZ = (int) org.joml.Math.signum(ray.dZ);
 
+        TilePos qPos = new TilePos();
         TilePos tilePos = new TilePos(ray.oX, ray.oY, ray.oZ);
 
         double sideDistX = -(ray.oX - (tilePos.x + 0.5)) * (1 / ray.dX) + 0.5 * dDistX;
@@ -218,10 +219,18 @@ public class Particle {
 
         Direction direction = Direction.NONE;
         while (dx * dx + dy * dy + dz * dz < length * length + 4) {
-            Block<?> block = this.world.getBlockType(tilePos);
-            if (block != null && collidesWithBlock(block, this.world.getBlockData(tilePos))) {
-                this.aabbs.clear();
-                block.getCollisionAABBs(this.world, tilePos, this.refAABB.setMin(tilePos.x, tilePos.y, tilePos.z).setMax(tilePos.x + 1, tilePos.y + 1, tilePos.z + 1), this.aabbs);
+            this.aabbs.clear();
+            for (int _x = -1; _x <= 1; _x++) {
+                for (int _y = -1; _y <= 1; _y++) {
+                    for (int _z = -1; _z <= 1; _z++) {
+                        Block<?> block = this.world.getBlockType(tilePos.add(_x, _y, _z, qPos));
+                        if (collidesWithBlock(block, this.world.getBlockData(qPos))) {
+                            block.getCollisionAABBs(this.world, qPos, this.refAABB.setMin(qPos.x, qPos.y, qPos.z).setMax(qPos.x + 1, qPos.y + 1, qPos.z + 1), this.aabbs);
+                        }
+                    }
+                }
+            }
+            if (!this.aabbs.isEmpty()) {
                 double tMin = Double.MAX_VALUE;
                 for (int i = 0, aabbsSize = this.aabbs.size(); i < aabbsSize; i++) {
                     if (this.aabbs.get(i).intersectsRay(ray, this.__r)) {
@@ -234,7 +243,6 @@ public class Particle {
                         direction.getSide(),
                         new Vector3d(ray.oX + tMin * ray.dX, ray.oY + tMin * ray.dY, ray.oZ + tMin * ray.dZ));
                 }
-                return null;
             }
 
             if (Double.isFinite(sideDistX) && sideDistX < sideDistY && sideDistX < sideDistZ) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index b919a180e..a61e89499 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -12,25 +11,26 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ParticleBlockBreaking extends Particle {
     private final Block<?> block;
     private final Side side;
-    private TilePos initPos = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
+    private final @NotNull TilePos initPos = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
     public ParticleBlockBreaking(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
         super(world, x, y, z, xa, ya, za);
         this.side = side;
         this.block = block;
         this.tex = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
-        this.gravity = block != null ? block.blockParticleGravity : 0;
+        this.gravity = block.blockParticleGravity;
         this.rCol = this.gCol = this.bCol = 0.6F;
         this.size /= 2.0F;
     }
 
-    public ParticleBlockBreaking init(@NotNull TilePos tilePos) {
-        this.initPos = tilePos;
+    public ParticleBlockBreaking init(@NotNull TilePosc tilePos) {
+        this.initPos.set(tilePos);
         int meta = this.world.getBlockData(tilePos);
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(this.block);
         int index = model.particleColorIndex(this.world, tilePos, this.side, meta);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index beb82d684..69a295c2c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
@@ -10,14 +12,21 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
+public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry> {
     private static ParticleDispatcher INSTANCE = new ParticleDispatcher();
-    private static final ParticleLambda BLANK = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
+    private static final ParticleEntry BLANK = new ParticleEntry() {
+        @Override
+        public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+            return null;
+        }
+    };
 
     public static ParticleDispatcher getInstance() {
         return INSTANCE;
@@ -28,54 +37,200 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
     }
 
     @Override
-    protected ParticleLambda getDefault() {
+    protected ParticleEntry getDefault() {
         return BLANK;
     }
 
     private ParticleDispatcher() {
         INSTANCE = this;
         Minecraft mc = Minecraft.getMinecraft();
-        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true));
-        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 1.0f, data));
-        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleNote(world, x, y, z, motionX, motionY, motionZ, data));
-        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePortal(world, x, y, z, motionX, motionY, motionZ, data));
-        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleExplode(world, x, y, z, motionX, motionY, motionZ));
-        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.ORANGE));
-        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.BLUE));
-        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.SOUL));
-        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleLava(world, x, y, z));
-        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFootstep(mc.textureManager, world, x, y, z));
-        addDispatch("splash", (world1, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSplash(world1, x, y, z, motionX, motionY, motionZ));
-        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 2.5f, data));
-        addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
-        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init(new TilePos(x, y, z)));
-        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ));
-        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleHeart(world, x, y, z, motionX, motionY, motionZ));
-        addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            if (mc.gameSettings.slimeParticles.value) {
+        addDispatch("bubble", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true);
+            }
+        });
+        addDispatch("smoke", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 1.0f, data);
+            }
+        });
+        addDispatch("note", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleNote(world, x, y, z, motionX, motionY, motionZ, data);
+            }
+        });
+        addDispatch("portal", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticlePortal(world, x, y, z, motionX, motionY, motionZ, data);
+            }
+        });
+        addDispatch("explode", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleExplode(world, x, y, z, motionX, motionY, motionZ);
+            }
+        });
+        addDispatch("flame", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.ORANGE);
+            }
+        });
+        addDispatch("blueflame", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.BLUE);
+            }
+        });
+        addDispatch("soulflame", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.SOUL);
+            }
+        });
+        addDispatch("lava", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleLava(world, x, y, z);
+            }
+        });
+        addDispatch("footstep", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFootstep(mc.textureManager, world, x, y, z);
+            }
+        });
+        addDispatch("splash", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleSplash(world, x, y, z, motionX, motionY, motionZ);
+            }
+        });
+        addDispatch("largesmoke", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 2.5f, data);
+            }
+        });
+        addDispatch("puffrgb", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data);
+            }
+        });
+        addDispatch("reddust", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleRedstoneDust(world, x, y, z, data);
+            }
+        });
+        addDispatch("item", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]);
+            }
+        });
+        addDispatch("block", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init(new TilePos(x, y, z));
+            }
+        });
+        addDispatch("snowshovel", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ);
+            }
+        });
+        addDispatch("heart", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleHeart(world, x, y, z, motionX, motionY, motionZ);
+            }
+
+            @Override
+            public boolean enabled() {
+                return GameSettings.PARTICLES_QUALITY.value != ParticlesQuality.NONE;
+            }
+        });
+        addDispatch("slimechunk", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
                 return new ParticleSlimeChunk(world, x, y, z, Items.SLIMEBALL);
             }
-            return null;
+
+            @Override
+            public boolean enabled() {
+                return GameSettings.SLIME_PARTICLES.value;
+            }
         });
-        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.GREEN.getId()));
-        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.BLUE.getId()));
-        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.ORANGE.getId()));
-        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.RED.getId()));
-        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleArrowGolden(world, x, y, z, motionX, motionY, motionZ));
-        addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            TilePos tilePos = new TilePos(x, y, z);
-            if (!world.isAirBlock(tilePos)) {
-                return new ParticleLeaf(world, x, y, z, motionX, motionY, motionZ).init(tilePos);
+        addDispatch("fireflyGreen", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.GREEN.getId());
+            }
+        });
+        addDispatch("fireflyBlue", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.BLUE.getId());
             }
-            return null;
         });
-        addDispatch("dripWater", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 0);
-            return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
+        addDispatch("fireflyOrange", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.ORANGE.getId());
+            }
+        });
+        addDispatch("fireflyRed", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.RED.getId());
+            }
+        });
+        addDispatch("arrowtrail", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleArrowGolden(world, x, y, z, motionX, motionY, motionZ);
+            }
+
+            @Override
+            public boolean enabled() {
+                return GameSettings.PARTICLES_QUALITY.value != ParticlesQuality.NONE;
+            }
+        });
+        addDispatch("fallingleaf", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                TilePos tilePos = new TilePos(x, y, z);
+                if (!world.isAirBlock(tilePos)) {
+                    return new ParticleLeaf(world, x, y, z, motionX, motionY, motionZ).init(tilePos);
+                }
+                return null;
+            }
+        });
+        addDispatch("dripWater", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, new TilePos(x, y, z), 0);
+                return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
+            }
+        });
+        addDispatch("dripLava", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright();
+            }
+        });
+        addDispatch("ashmote", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleAsh(world, x, y, z, 0, 0, 0);
+            }
         });
-        addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright());
-        addDispatch("ashmote", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleAsh(world, x, y, z, 0, 0, 0));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java
new file mode 100644
index 000000000..23b8917d5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java
@@ -0,0 +1,13 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.ParticlesQuality;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+public abstract class ParticleEntry {
+    public abstract Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
+    public boolean enabled() {
+        return GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.ALL;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index f60caeff7..25868a062 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.renderer;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.FogManager;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
@@ -156,7 +157,7 @@ public class GLRenderer {
         shader.uniformFloat("uPartialTick", instance.mc.timer.partialTicks);
         shader.uniformFloat("uLineWidth", instance.currentLineWidth);
 
-        double renderScale = (float) instance.mc.gameSettings.renderScale.value.scale;
+        double renderScale = (float) GameSettings.RENDER_SCALE.value.scale;
         int scaledWidth = (int) (renderScale * instance.mc.gameWindow.getWidthPixels());
         int scaledHeight = (int) (renderScale * instance.mc.gameWindow.getHeightPixels());
         shader.uniformVec2f("uViewPortSize", scaledWidth, scaledHeight);
